(function($){
    /**带图标的组合框ZLComboBox控件**/
    $.fn.czl_combobox = function( options )
    {
	   this.each( function()  
	   {
		  var instance = $.data( this , 'czl_combobox' );
		  if( !instance )
		  {
			$.data( this, 'czl_combobox' , new $.ZLComboBox( options , this ) );  //主体功能通过一个对象实现 
		  }
		  
	   });//end of each
	   
	   return this;  
    };
	$.ZLComboBox = function( options , element )
	{	
		this.$el= $( element ); 
		this._init( options );
	};
	 
	//默认值设置
	$.ZLComboBox.defaults = {
		selectItemEvent:function( index ){
			alert( index );
			return ;
		}
	};
	 
	$.ZLComboBox.prototype = {   
		  _init : function( options )
		  {
			this.options = $.extend( true , {} , $.ZLComboBox.defaults , options );
			
			//相关的控件
			this.comboBox = this.$el ;
			
			//相关的HTML控件
			this.cb_btn = this.comboBox.children( '.cb_btn' ).eq(0);
			this.cb_input = this.comboBox.children( '.cb_input' ).eq(0);
			this.cb_item = this.comboBox.find( 'li' );

			//控件的状态，标记是否显示下拉列表
			this.cb_showitem_status = false ;     
			
			//初始化默认的值，默认选中最后一个选项
			this.selected_index = this.cb_item.length-1 ;                       
			this.cb_input.html( this.cb_item.eq(this.selected_index).html() );  

			//注册响应事件
			this._loadEvents();
		  },
		 _show_itemlist:function(){
				if( this.cb_showitem_status === false ){
					this.comboBox.addClass( 'selected' );
					this.cb_showitem_status = true;
				}
				else{
					this.comboBox.removeClass( 'selected' );
					this.cb_showitem_status = false;
				}
				return ;
		 },
		 _loadEvents:function(){
			var _self = this;   
			//1_单击下拉箭头
			this.cb_btn.on( 'click' , function( event ){ 
				_self._show_itemlist( );
				return ;
			});
			//2_单击编辑框，也同样进行下拉框的状态切换
			this.cb_input.on( 'click' , function( event ){ 
				_self._show_itemlist( );
				return ;
			});
			//3_单击选项
			this.cb_item.on( 'click' , function( event ){ 
				var index = $(this).index();
				if( _self.selected_index !== index ){
					//设置选项的值
					_self.cb_input.html( $(this).html() );
					
					//设置当前选中的项
					_self.selected_index = index ;
					
					//隐藏下拉框
					_self._show_itemlist();

					//调用回调函数
					_self.options.selectItemEvent( index );
				}
				return ;
			});
		 },
		 getSelectedIndex:function(){
				return this.selected_index;
		 }
	  };
   
}(jQuery));
